#include <iostream>
#define _USE_MATH_DEFINES
#include <math.h>

struct LinkLength
{
  double l0;
  double l1;
};
struct Position
{
  double x;
  double y;
};
struct JointAngle
{
  double th0;
  double th1;
};

JointAngle invkinem(LinkLength link, Position pos)
{
  double ld(/* ldの長さをpos.x, pos.y から求める */);
  double l1(link.l0);
  double l2(link.l1);

  double a  = /* 角度αを acos() と l1, l2, ld から求める */;
  double b  = /* 角度βを acos() と l1, l2, ld から求める */;
  double phi = /* 角度φ を atan2() と pos.y, pos.x から求める*/;

  JointAngle j;
  j.th0 = /* θ1をαとφから求める */;
  j.th1 = /* θ2をβから求める */;

  return j;
}

int main(void)
{
  LinkLength l = {1.0, 1.0};
  Position pos[] = {
    {-1.0, 1.0},
    {-0.5, 1.0},
    { 0.0, 1.0},
    { 0.5, 1.0},
    { 1.0, 1.0},
  };

  for (int i(0); i < 5; ++i)
    {
      JointAngle j = invkinem(l, pos[i]);
      std::cout << "pos (x, y): " << pos[i].x << ", " << pos[i].y << "\t ==> ";
      std::cout << "angle (th0, th1): " << j.th0 << ", " << j.th1 << std::endl;
    }

  return 0;
}
